diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/in_rss.c user/rwatson/tcp/src/sys/netinet/in_rss.c
--- vendor/freebsd/src/sys/netinet/in_rss.c	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/netinet/in_rss.c	2011-02-01 08:30:20.600604108 +0000
@@ -0,0 +1,525 @@
+/*-
+ * Copyright (c) 2010-2011 Juniper Networks, Inc.
+ * All rights reserved.
+ *
+ * This software was developed by Robert N. M. Watson under contract
+ * to Juniper Networks, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#include <sys/cdefs.h>
+
+__FBSDID("$FreeBSD$");
+
+#include "opt_inet6.h"
+#include "opt_pcbgroup.h"
+
+#ifndef PCBGROUP
+#error "options RSS depends on options PCBGROUP"
+#endif
+
+#include <sys/param.h>
+#include <sys/systm.h>
+#include <sys/malloc.h>
+#include <sys/mbuf.h>
+#include <sys/domain.h>
+#include <sys/protosw.h>
+#include <sys/socket.h>
+#include <sys/socketvar.h>
+#include <sys/priv.h>
+#include <sys/proc.h>
+#include <sys/refcount.h>
+#include <sys/jail.h>
+#include <sys/kernel.h>
+#include <sys/smp.h>
+#include <sys/sysctl.h>
+
+#include <vm/uma.h>
+
+#include <net/if.h>
+#include <net/if_types.h>
+#include <net/netisr.h>
+#include <net/route.h>
+#include <net/vnet.h>
+
+#include <netinet/in.h>
+#include <netinet/in_pcb.h>
+#include <netinet/in_rss.h>
+#include <netinet/in_var.h>
+#include <netinet/ip_var.h>
+#include <netinet/tcp_var.h>
+#include <netinet/toeplitz.h>
+#include <netinet/udp.h>
+#include <netinet/udp_var.h>
+#ifdef INET6
+#include <netinet/ip6.h>
+#include <netinet6/in6_pcb.h>
+#include <netinet6/ip6_var.h>
+#endif /* INET6 */
+
+/*-
+ * Operating system parts of receiver-side steering (RSS), which allows
+ * network cards to direct flows to particular receive queues based on hashes
+ * if header tuples.  This implementation aligns RSS buckets with connection
+ * groups at the TCP/IP layer, so each bucket is associated with exactly one
+ * group.  As a result, the group lookup structures (and lock) should have an
+ * effective affinity with exactly one CPU.
+ *
+ * Network device drivers needing to configure RSS will query this framework
+ * for parameters, such as the current RSS key, hashing policies, number of
+ * bits, and indirection table mapping hashes to buckets and CPUs.  They may
+ * provide their own supplementary information, such as queue<->CPU bindings.
+ * It is the responsibility of the network device driver to inject packets
+ * into the stack on as close to the right CPU as possible, if playing by RSS
+ * rules.
+ *
+ * TODO:
+ *
+ * - Synchronization for rss_key and other future-configurable parameters.
+ * - Event handler drivers can register to pick up RSS configuration changes.
+ * - Should we allow rss_basecpu to be configured?
+ * - Randomize key on boot.
+ * - IPv6 support.
+ * - Statistics on how often there's a misalignment between hardware
+ *   placement and pcbgroup expectations.
+ */
+
+SYSCTL_NODE(_net_inet, OID_AUTO, rss, CTLFLAG_RW, 0, "Receive-side steering");
+
+/*
+ * Toeplitz is the only required hash function in the RSS spec, so use it by
+ * default.
+ */
+static u_int	rss_hashalgo = RSS_HASH_TOEPLITZ;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, hashalgo, CTLFLAG_RD, &rss_hashalgo, 0,
+    "RSS hash algorithm");
+TUNABLE_INT("net.inet.rss.hashalgo", &rss_hashalgo);
+
+/*
+ * Size of the indirection table; at most 128 entries per the RSS spec.  We
+ * size it to at least 2 times the number of CPUs by default to allow useful
+ * rebalancing.  If not set explicitly with a loader tunable, we tune based
+ * on the number of CPUs present.
+ *
+ * XXXRW: buckets might be better to use for the tunable than bits.
+ */
+static u_int	rss_bits;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, bits, CTLFLAG_RD, &rss_bits, 0,
+    "RSS bits");
+TUNABLE_INT("net.inet.rss.bits", &rss_bits);
+
+static u_int	rss_mask;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, mask, CTLFLAG_RD, &rss_mask, 0,
+    "RSS mask");
+
+static const u_int	rss_maxbits = RSS_MAXBITS;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, maxbits, CTLFLAG_RD,
+    __DECONST(int *, &rss_maxbits), 0, "RSS maximum bits");
+
+/*
+ * RSS's own count of the number of CPUs it could be using for processing.
+ * Bounded to 64 by RSS constants.
+ */
+static u_int	rss_ncpus;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, ncpus, CTLFLAG_RD, &rss_ncpus, 0,
+    "Number of CPUs available to RSS");
+
+#define	RSS_MAXCPUS	(1 << (RSS_MAXBITS - 1))
+static const u_int	rss_maxcpus = RSS_MAXCPUS;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, maxcpus, CTLFLAG_RD,
+    __DECONST(int *, &rss_maxcpus), 0, "RSS maximum CPUs that can be used");
+
+/*
+ * Variable exists just for reporting rss_bits in a user-friendly way.
+ */
+static u_int	rss_buckets;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, buckets, CTLFLAG_RD, &rss_buckets, 0,
+    "RSS buckets");
+
+/*
+ * Base CPU number; devices will add this to all CPU numbers returned by the
+ * RSS indirection table.  Currently unmodifable in FreeBSD.
+ */
+static const u_int	rss_basecpu;
+SYSCTL_INT(_net_inet_rss, OID_AUTO, basecpu, CTLFLAG_RD,
+    __DECONST(int *, &rss_basecpu), 0, "RSS base CPU");
+
+/*
+ * RSS secret key, intended to prevent attacks on load-balancing.  Its
+ * effectiveness may be limited by algorithm choice and available entropy
+ * during the boot.
+ *
+ * XXXRW: And that we don't randomize it yet!
+ *
+ * XXXRW: This default is actually the default key from Chelsio T3 cards, as
+ * it offers reasonable distribution, unlike all-0 keys which always
+ * generate a hash of 0 (upsettingly).
+ */
+static uint8_t	rss_key[RSS_KEYSIZE] = {
+	0x43, 0xa3, 0x8f, 0xb0, 0x41, 0x67, 0x25, 0x3d,
+	0x25, 0x5b, 0x0e, 0xc2, 0x6d, 0x5a, 0x56, 0xda,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
+};
+
+/*
+ * RSS hash->CPU table, which maps hashed packet headers to particular CPUs.
+ * Drivers may supplement this table with a seperate CPU<->queue table when
+ * programming devices.
+ */
+struct rss_table_entry {
+	uint8_t		rte_cpu;	/* CPU affinity of bucket. */
+};
+static struct rss_table_entry	rss_table[RSS_TABLE_MAXLEN];
+
+static void
+rss_init(__unused void *arg)
+{
+	u_int i;
+
+	/*
+	 * Validate tunables, coerce to sensible values.
+	 */
+	switch (rss_hashalgo) {
+	case RSS_HASH_TOEPLITZ:
+	case RSS_HASH_NAIVE:
+		break;
+
+	default:
+		printf("rss_init: invalid RSS hashalgo %u, coercing to %u",
+		    rss_hashalgo, RSS_HASH_TOEPLITZ);
+		rss_hashalgo = RSS_HASH_TOEPLITZ;
+	}
+
+	/*
+	 * Count available CPUs.
+	 *
+	 * XXXRW: Note incorrect assumptions regarding contiguity of this set
+	 * elsewhere.
+	 */
+	rss_ncpus = 0;
+	for (i = 0; i <= mp_maxid; i++) {
+		if (CPU_ABSENT(i))
+			continue;
+		rss_ncpus++;
+	}
+	if (rss_ncpus > RSS_MAXCPUS)
+		rss_ncpus = RSS_MAXCPUS;
+
+	/*
+	 * Tune RSS table entries to be no less than 2x the number of CPUs
+	 * -- unless we're running uniprocessor, in which case there's not
+	 * much point in having buckets to rearrange for load-balancing!
+	 */
+	if (rss_ncpus > 1) {
+		if (rss_bits == 0)
+			rss_bits = fls(rss_ncpus - 1) + 1;
+
+		/*
+		 * Microsoft limits RSS table entries to 128, so apply that
+		 * limit to both auto-detected CPU counts and user-configured
+		 * ones.
+		 */
+		if (rss_bits == 0 || rss_bits > RSS_MAXBITS) {
+			printf("rss_init: RSS bits %u not valid, coercing to "
+			    " %u", rss_bits, RSS_MAXBITS);
+			rss_bits = RSS_MAXBITS;
+		}
+
+		/*
+		 * Figure out how many buckets to use; warn if less than the
+		 * number of configured CPUs, although this is not a fatal
+		 * problem.
+		 */
+		rss_buckets = (1 << rss_bits);
+		if (rss_buckets < rss_ncpus)
+			printf("rss_init: WARNING: rss_buckets (%u) less than "
+			    "rss_ncpus (%u)\n", rss_buckets, rss_ncpus);
+		rss_mask = rss_buckets - 1;
+	} else {
+		rss_bits = 0;
+		rss_buckets = 1;
+		rss_mask = 0;
+	}
+
+	/*
+	 * Set up initial CPU assignments: round-robin by default.
+	 *
+	 * XXXRW: Need a mapping to non-contiguous IDs here.
+	 */
+	for (i = 0; i < rss_buckets; i++)
+		rss_table[i].rte_cpu = i % rss_ncpus;
+
+	/*
+	 * Randomize rrs_key.
+	 *
+	 * XXXRW: Not yet.  If nothing else, will require an rss_isbadkey()
+	 * loop to check for "bad" RSS keys.
+	 */
+}
+SYSINIT(rss_init, SI_SUB_SOFTINTR, SI_ORDER_SECOND, rss_init, NULL);
+
+static uint32_t
+rss_naive_hash(u_int keylen, const uint8_t *key, u_int datalen,
+    const uint8_t *data)
+{
+	uint32_t v;
+	u_int i;
+
+	v = 0;
+	for (i = 0; i < keylen; i++)
+		v += key[i];
+	for (i = 0; i < datalen; i++)
+		v += data[i];
+	return (v);
+}
+
+static uint32_t
+rss_hash(u_int datalen, const uint8_t *data)
+{
+ 
+	switch (rss_hashalgo) {
+	case RSS_HASH_TOEPLITZ:
+		return (toeplitz_hash(sizeof(rss_key), rss_key, datalen,
+		    data));
+
+	case RSS_HASH_NAIVE:
+		return (rss_naive_hash(sizeof(rss_key), rss_key, datalen,
+		    data));
+
+	default:
+		panic("rss_hash: unsupported/unknown hashalgo %d",
+		    rss_hashalgo);
+	}
+}
+
+/*
+ * Hash an IPv4 2-tuple.
+ */
+uint32_t
+rss_hash_ip4_2tuple(struct in_addr src, struct in_addr dst)
+{
+	uint8_t data[sizeof(src) + sizeof(dst)];
+	u_int datalen;
+
+	datalen = 0;
+	bcopy(&src, &data[datalen], sizeof(src));
+	datalen += sizeof(src);
+	bcopy(&dst, &data[datalen], sizeof(dst));
+	datalen += sizeof(dst);
+	return (rss_hash(datalen, data));
+}
+
+/*
+ * Hash an IPv4 4-tuple.
+ */
+uint32_t
+rss_hash_ip4_4tuple(struct in_addr src, u_short srcport, struct in_addr dst,
+    u_short dstport)
+{
+	uint8_t data[sizeof(src) + sizeof(dst) + sizeof(srcport) +
+	    sizeof(dstport)];
+	u_int datalen;
+
+	datalen = 0;
+	bcopy(&src, &data[datalen], sizeof(src));
+	datalen += sizeof(src);
+	bcopy(&dst, &data[datalen], sizeof(dst));
+	datalen += sizeof(dst);
+	bcopy(&srcport, &data[datalen], sizeof(srcport));
+	datalen += sizeof(srcport);
+	bcopy(&dstport, &data[datalen], sizeof(dstport));
+	datalen += sizeof(dstport);
+	return (rss_hash(datalen, data));
+}
+
+#ifdef INET6
+/*
+ * Hash an IPv6 2-tuple.
+ */
+uint32_t
+rss_hash_ip6_2tuple(struct in6_addr src, struct in6_addr dst)
+{
+	uint8_t data[sizeof(src) + sizeof(dst)];
+	u_int datalen;
+
+	datalen = 0;
+	bcopy(&src, &data[datalen], sizeof(src));
+	datalen += sizeof(src);
+	bcopy(&dst, &data[datalen], sizeof(dst));
+	datalen += sizeof(dst);
+	return (rss_hash(datalen, data));
+}
+
+/*
+ * Hash an IPv6 4-tuple.
+ */
+uint32_t
+rss_hash_ip6_4tuple(struct in6_addr src, u_short srcport,
+    struct in6_addr dst, u_short dstport)
+{
+	uint8_t data[sizeof(src) + sizeof(dst) + sizeof(srcport) +
+	    sizeof(dstport)];
+	u_int datalen;
+
+	datalen = 0;
+	bcopy(&src, &data[datalen], sizeof(src));
+	datalen += sizeof(src);
+	bcopy(&dst, &data[datalen], sizeof(dst));
+	datalen += sizeof(dst);
+	bcopy(&srcport, &data[datalen], sizeof(srcport));
+	datalen += sizeof(srcport);
+	bcopy(&dstport, &data[datalen], sizeof(dstport));
+	datalen += sizeof(dstport);
+	return (rss_hash(datalen, data));
+}
+#endif /* INET6 */
+
+/*
+ * Query the number of RSS bits in use.
+ */
+u_int
+rss_getbits(void)
+{
+
+	return (rss_bits);
+}
+
+/*
+ * Query the RSS bucket associated with an RSS hash.
+ */
+u_int
+rss_getbucket(u_int hash)
+{
+
+	return (hash & rss_mask);
+}
+
+/*
+ * Query the RSS CPU associated with an RSS bucket.
+ */
+u_int
+rss_getcpu(u_int bucket)
+{
+
+	return (rss_table[bucket].rte_cpu);
+}
+
+/*
+ * netisr CPU affinity lookup routine for use by protocols.
+ */
+struct mbuf *
+rss_m2cpuid(struct mbuf *m, uintptr_t source, u_int *cpuid)
+{
+
+	M_ASSERTPKTHDR(m);
+
+	switch (M_HASHTYPE_GET(m)) {
+	case M_HASHTYPE_RSS_2TUPLE:
+	case M_HASHTYPE_RSS_4TUPLE:
+		*cpuid = rss_getcpu(rss_getbucket(m->m_pkthdr.flowid));
+		return (m);
+
+	default:
+		*cpuid = NETISR_CPUID_NONE;
+		return (m);
+	}
+}
+
+/*
+ * Query the RSS hash algorithm.
+ */
+u_int
+rss_gethashalgo(void)
+{
+
+	return (rss_hashalgo);
+}
+
+/*
+ * Query the current RSS key; likely to be used by device drivers when
+ * configuring hardware RSS.  Caller must pass an array of size RSS_KEYSIZE.
+ *
+ * XXXRW: Perhaps we should do the accept-a-length-and-truncate thing?
+ */
+void
+rss_getkey(uint8_t *key)
+{
+
+	bcopy(rss_key, key, sizeof(rss_key));
+}
+
+/*
+ * Query the number of buckets; this may be used by both network device
+ * drivers, which will need to populate hardware shadows of the software
+ * indirection table, and the network stack itself (such as when deciding how
+ * many connection groups to allocate).
+ */
+u_int
+rss_getnumbuckets(void)
+{
+
+	return (rss_buckets);
+}
+
+/*
+ * Query the number of CPUs in use by RSS; may be useful to device drivers
+ * trying to figure out how to map a larger number of CPUs into a smaller
+ * number of receive queues.
+ */
+u_int
+rss_getnumcpus(void)
+{
+
+	return (rss_ncpus);
+}
+
+/*
+ * XXXRW: Confirm that sysctl -a won't dump this keying material, don't want
+ * it appearing in debugging output unnecessarily.
+ */
+static int
+sysctl_rss_key(SYSCTL_HANDLER_ARGS)
+{
+	uint8_t temp_rss_key[RSS_KEYSIZE];
+	int error;
+
+	error = priv_check(req->td, PRIV_NETINET_HASHKEY);
+	if (error)
+		return (error);
+
+	bcopy(rss_key, temp_rss_key, sizeof(temp_rss_key));
+	error = sysctl_handle_opaque(oidp, temp_rss_key,
+	    sizeof(temp_rss_key), req);
+	if (error)
+		return (error);
+	if (req->newptr != NULL) {
+		/* XXXRW: Not yet. */
+		return (EINVAL);
+	}
+	return (0);
+}
+SYSCTL_PROC(_net_inet_rss, OID_AUTO, key,
+    CTLTYPE_OPAQUE | CTLFLAG_RD | CTLFLAG_MPSAFE, NULL, 0, sysctl_rss_key,
+    "", "RSS keying material");
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/in_rss.h user/rwatson/tcp/src/sys/netinet/in_rss.h
--- vendor/freebsd/src/sys/netinet/in_rss.h	1970-01-01 01:00:00.000000000 +0100
+++ user/rwatson/tcp/src/sys/netinet/in_rss.h	2011-02-01 08:30:20.723504365 +0000
@@ -0,0 +1,92 @@
+/*-
+ * Copyright (c) 2010-2011 Juniper Networks, Inc.
+ * All rights reserved.
+ *
+ * This software was developed by Robert N. M. Watson under contract
+ * to Juniper Networks, Inc.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+#ifndef _NETINET_IN_RSS_H_
+#define	_NETINET_IN_RSS_H_
+
+#include <netinet/in.h>		/* in_addr_t */
+
+/*
+ * Supported RSS hash functions.
+ */
+#define	RSS_HASH_NAIVE		0x00000001	/* Poor but fast hash. */
+#define	RSS_HASH_TOEPLITZ	0x00000002	/* Required by RSS. */
+#define	RSS_HASH_CRC32		0x00000004	/* Future; some NICs do it. */
+
+#define	RSS_HASH_MASK		(RSS_HASH_NAIVE | RSS_HASH_TOEPLITZ)
+
+/*
+ * Instances of struct inpcbinfo declare an RSS hash type indicating what
+ * header fields are covered.
+ */
+#define	RSS_HASHFIELDS_NONE		0
+#define	RSS_HASHFIELDS_4TUPLE		1
+#define	RSS_HASHFIELDS_2TUPLE		2
+
+/*
+ * Compile-time limits on the size of the indirection table.
+ */
+#define	RSS_MAXBITS	7
+#define	RSS_TABLE_MAXLEN	(1 << RSS_MAXBITS)
+
+/*
+ * Maximum key size used throughout.  It's OK for hardware to use only the
+ * first 16 bytes, which is all that's required for IPv4.
+ */
+#define	RSS_KEYSIZE	40
+
+/*
+ * Device driver interfaces to query RSS properties that must be programmed
+ * into hardware.
+ */
+u_int	rss_getbits(void);
+u_int	rss_getbucket(u_int hash);
+u_int	rss_getcpu(u_int bucket);
+void	rss_getkey(uint8_t *key);
+u_int	rss_gethashalgo(void);
+u_int	rss_getnumbuckets(void);
+u_int	rss_getnumcpus(void);
+
+/*
+ * Network stack interface to generate a hash for a protocol tuple.
+ */
+uint32_t	rss_hash_ip4_4tuple(struct in_addr src, u_short srcport,
+		    struct in_addr dst, u_short dstport);
+uint32_t	rss_hash_ip4_2tuple(struct in_addr src, struct in_addr dst);
+uint32_t	rss_hash_ip6_4tuple(struct in6_addr src, u_short srcport,
+		    struct in6_addr dst, u_short dstport);
+uint32_t	rss_hash_ip6_2tuple(struct in6_addr src,
+		    struct in6_addr dst);
+
+/*
+ * Network stack interface to query desired CPU affinity of a packet.
+ */
+struct mbuf	*rss_m2cpuid(struct mbuf *m, uintptr_t source, u_int *cpuid);
+
+#endif /* !_NETINET_IN_RSS_H_ */
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/ip_divert.c user/rwatson/tcp/src/sys/netinet/ip_divert.c
--- vendor/freebsd/src/sys/netinet/ip_divert.c	2011-02-01 09:38:50.196618406 +0000
+++ user/rwatson/tcp/src/sys/netinet/ip_divert.c	2011-02-01 08:30:20.943440139 +0000
@@ -153,7 +153,8 @@
 	 * place for hashbase == NULL.
 	 */
 	in_pcbinfo_init(&V_divcbinfo, "div", &V_divcb, 1, 1, "divcb",
-	    div_inpcb_init, div_inpcb_fini, UMA_ZONE_NOFREE);
+	    div_inpcb_init, div_inpcb_fini, UMA_ZONE_NOFREE,
+	    IPI_HASHFIELDS_NONE);
 }
 
 static void
@@ -659,9 +660,9 @@
 	INP_INFO_WLOCK(&V_divcbinfo);
 	for (i = 0; i < n; i++) {
 		inp = inp_list[i];
-		INP_WLOCK(inp);
-		if (!in_pcbrele(inp))
-			INP_WUNLOCK(inp);
+		INP_RLOCK(inp);
+		if (!in_pcbrele_rlocked(inp))
+			INP_RUNLOCK(inp);
 	}
 	INP_INFO_WUNLOCK(&V_divcbinfo);
 
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/ip_var.h user/rwatson/tcp/src/sys/netinet/ip_var.h
--- vendor/freebsd/src/sys/netinet/ip_var.h	2011-02-01 09:38:50.613527818 +0000
+++ user/rwatson/tcp/src/sys/netinet/ip_var.h	2010-05-22 11:56:55.700208030 +0100
@@ -135,8 +135,13 @@
  * In-kernel consumers can use these accessor macros directly to update
  * stats.
  */
+#ifdef INET_NOSTATS
+#define	IPSTAT_ADD(name, val)
+#define	IPSTAT_SUB(name, val)
+#else
 #define	IPSTAT_ADD(name, val)	V_ipstat.name += (val)
 #define	IPSTAT_SUB(name, val)	V_ipstat.name -= (val)
+#endif
 #define	IPSTAT_INC(name)	IPSTAT_ADD(name, 1)
 #define	IPSTAT_DEC(name)	IPSTAT_SUB(name, 1)
 
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/ipfw/ip_fw2.c user/rwatson/tcp/src/sys/netinet/ipfw/ip_fw2.c
--- vendor/freebsd/src/sys/netinet/ipfw/ip_fw2.c	2011-02-01 09:38:51.215359894 +0000
+++ user/rwatson/tcp/src/sys/netinet/ipfw/ip_fw2.c	2011-01-30 14:25:51.823414835 +0000
@@ -656,7 +656,7 @@
 	    (struct bsd_ucred *)uc, ugid_lookupp, ((struct mbuf *)inp)->m_skb);
 #else  /* FreeBSD */
 	struct inpcbinfo *pi;
-	int wildcard;
+	int lookupflags;
 	struct inpcb *pcb;
 	int match;
 
@@ -681,30 +681,34 @@
 	if (*ugid_lookupp == -1)
 		return (0);
 	if (proto == IPPROTO_TCP) {
-		wildcard = 0;
+		lookupflags = 0;
 		pi = &V_tcbinfo;
 	} else if (proto == IPPROTO_UDP) {
-		wildcard = INPLOOKUP_WILDCARD;
+		lookupflags = INPLOOKUP_WILDCARD;
 		pi = &V_udbinfo;
 	} else
 		return 0;
+	lookupflags |= INPLOOKUP_RLOCKPCB;
 	match = 0;
 	if (*ugid_lookupp == 0) {
-		INP_INFO_RLOCK(pi);
+		/*
+		 * XXXRW: If we had the mbuf here, could use in_pcblookupm().
+		 */
 		pcb =  (oif) ?
-			in_pcblookup_hash(pi,
+			in_pcblookup(pi,
 				dst_ip, htons(dst_port),
 				src_ip, htons(src_port),
-				wildcard, oif) :
-			in_pcblookup_hash(pi,
+				lookupflags, oif) :
+			in_pcblookup(pi,
 				src_ip, htons(src_port),
 				dst_ip, htons(dst_port),
-				wildcard, NULL);
+				lookupflags, NULL);
 		if (pcb != NULL) {
+			INP_RLOCK_ASSERT(pcb);
 			*uc = crhold(pcb->inp_cred);
 			*ugid_lookupp = 1;
+			INP_RUNLOCK(pcb);
 		}
-		INP_INFO_RUNLOCK(pi);
 		if (*ugid_lookupp == 0) {
 			/*
 			 * We tried and failed, set the variable to -1
diff -urN -x compile -x LINT vendor/freebsd/src/sys/netinet/raw_ip.c user/rwatson/tcp/src/sys/netinet/raw_ip.c
--- vendor/freebsd/src/sys/netinet/raw_ip.c	2011-02-01 09:38:52.243772723 +0000
+++ user/rwatson/tcp/src/sys/netinet/raw_ip.c	2011-02-01 08:30:20.973383889 +0000
@@ -186,7 +186,8 @@
 {
 
 	in_pcbinfo_init(&V_ripcbinfo, "rip", &V_ripcb, INP_PCBHASH_RAW_SIZE,
-	    1, "ripcb", rip_inpcb_init, NULL, UMA_ZONE_NOFREE);
+	    1, "ripcb", rip_inpcb_init, NULL, UMA_ZONE_NOFREE,
+	    IPI_HASHFIELDS_NONE);
 	EVENTHANDLER_REGISTER(maxsockets_change, rip_zone_change, NULL,
 	    EVENTHANDLER_PRI_ANY);
 }
@@ -206,7 +207,7 @@
 {
 	int policyfail = 0;
 
-	INP_RLOCK_ASSERT(last);
+	INP_LOCK_ASSERT(last);
 
 #ifdef IPSEC
 	/* check AH/ESP integrity. */
@@ -814,16 +815,18 @@
 static void
 rip_dodisconnect(struct socket *so, struct inpcb *inp)
 {
+	struct inpcbinfo *pcbinfo = inp->inp_pcbinfo;
 
-	INP_INFO_WLOCK_ASSERT(inp->inp_pcbinfo);
-	INP_WLOCK_ASSERT(inp);
-
+	INP_INFO_WLOCK(pcbinfo);
+	INP_WLOCK(inp);
 	rip_delhash(inp);
 	inp->inp_faddr.s_addr = INADDR_ANY;
 	rip_inshash(inp);
 	SOCK_LOCK(so);
 	so->so_state &= ~SS_ISCONNECTED;
 	SOCK_UNLOCK(so);
+	INP_WUNLOCK(inp);
+	INP_INFO_WUNLOCK(pcbinfo);
 }
 
 static void
@@ -834,11 +837,7 @@
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("rip_abort: inp == NULL"));
 
-	INP_INFO_WLOCK(&V_ripcbinfo);
-	INP_WLOCK(inp);
 	rip_dodisconnect(so, inp);
-	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_ripcbinfo);
 }
 
 static void
@@ -849,11 +848,7 @@
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("rip_close: inp == NULL"));
 
-	INP_INFO_WLOCK(&V_ripcbinfo);
-	INP_WLOCK(inp);
 	rip_dodisconnect(so, inp);
-	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_ripcbinfo);
 }
 
 static int
@@ -867,11 +862,7 @@
 	inp = sotoinpcb(so);
 	KASSERT(inp != NULL, ("rip_disconnect: inp == NULL"));
 
-	INP_INFO_WLOCK(&V_ripcbinfo);
-	INP_WLOCK(inp);
 	rip_dodisconnect(so, inp);
-	INP_WUNLOCK(inp);
-	INP_INFO_WUNLOCK(&V_ripcbinfo);
 	return (0);
 }
 
@@ -1056,9 +1047,9 @@
 	INP_INFO_WLOCK(&V_ripcbinfo);
 	for (i = 0; i < n; i++) {
 		inp = inp_list[i];
-		INP_WLOCK(inp);
-		if (!in_pcbrele(inp))
-			INP_WUNLOCK(inp);
+		INP_RLOCK(inp);
+		if (!in_pcbrele_rlocked(inp))
+			INP_RUNLOCK(inp);
 	}
 	INP_INFO_WUNLOCK(&V_ripcbinfo);
 
